var util	= require('util'),
	exec	= require('child_process').exec,
	npath	= require('path'),
	cs		= require('./../change_case'),
	fs		= require("fs"),
	ncp		= require("ncp"),
	CleanCSS= require('clean-css'),
	depend	= require('./../dependency'),
	jsdom	= require("jsdom"),
	Concat	= require('concat-with-sourcemaps');

var clc		= null,
	func	= null,
	wd		= null,
	cfg		= null,
	depSort	= [];

module.exports=function(fu){
	func=fu;
	clc=func.clc;
	wd=func.workingdir;
	try {
		cfg=require(wd+'esm.json');
	} catch(err) {
		cfg=null;
	}
	return {
		hint:function(){
			if (cfg) {
				hints('check app    : ','appJsDir','app/js',function(){
					hints('check editor : ','editorJsDir','editor/js');
				});
			} else {
				console.log(clc.error('esm.json not found or not valid'));
			}
		},
		bundle:function(){
			//console.log(func.p); return;
			if (cfg && cfg.name) {
				console.log('APP : ');
				builds(' build "'+cfg.name+'.js" for app    : ','appJsDir','app/js','appBuildSource','appStaticDir','app/static','appDistDir','dist/app',function(){
					console.log('EDITOR : ');
					builds(' build "'+cfg.name+'.js" for editor : ','editorJsDir','editor/js','editorBuildSource','editorStaticDir','editor/static','editorDistDir','dist/editor');
				});
			} else {
				console.log(clc.error('esm.json not found or not valid'));
			}
		},
		test:function(){
			//if (cfg && cfg.name) {
			//	tests('editorLibDependencies','editorDistDir','dist/editor');
			//} else {
			//	console.log(clc.error('esm.json not found or not valid'));
			//}
			//var appdeps={
			//	"libs":{
			//		"jquery":{
			//			"css":[],
			//			"js":[".\/esm_libs\/jquery\/jquery.js"]}},
			//	"modules":{}
			//}

			if (cfg && cfg.name) {
				console.log('APP : ');
				//tests(' test "'+cfg.name+'.js" for app    : ',appdeps,'appDistDir','dist/app',function(){
				//	console.log('EDITOR : ');
				//	tests(' test "'+cfg.name+'.js" for app    : ',{},'appDistDir','dist/app');
				//});
				tests('xx','xxx',function(){
					console.log('EDITOR : ');
					tests('','');
				});
			} else {
				console.log(clc.error('esm.json not found or not valid'));
			}
			//if (cfg) {
			//	cfg.editorLibDependencies=cfg.editorLibDependencies||[];
			//	if (!util.isArray(cfg.editorLibDependencies)) {
			//		cfg.editorLibDependencies=[cfg.editorLibDependencies];
			//	}
			//	var adeps=depend.lib(cfg.editorLibDependencies,wd+'esm_libs/');
			//	//console.log(adeps);
			//	//console.log(depend.sort(adeps));
			//	depSort:depend.sort(adeps);
			//} else {
			//	console.log(clc.error('esm.json not found'));
			//}
			//return;
			//var cfg=require(wd+'esm.json');
			//if (cfg && cfg.name) {
			//	var jsdom = require("jsdom");
			//	var scri=[];
			//	cfg.testScript=cfg.testScript||[];
			//	for (var i=0;i<cfg.testScript.length;i++){
			//		scri.push(wd+cfg.testScript[i]);
			//	}
			//	cfg.appDistDir=cfg.appDistDir||'dist/app';
			//	
			//	scri.push(wd+cfg.appDistDir+'/'+cfg.name+'.js');
			//	//console.log(scri);
			//	jsdom.env(
			//		'<p><a class="the-link" href="https://github.com/tmpvar/jsdom">jsdom!</a></p>',
			//		{
			//			scripts: scri,
			//			done: function (errors, window) {
			//				console.log(window.document.documentElement.outerHTML);
			//				if (errors) {
			//					func.formatOutput(errors);
			//				} else {
			//					console.log(clc.white(cfg.name+' global ('+clc.bold('window.'+cs.camel(cfg.name))+') :'));
			//					console.log(window.emobiqApp);
			//					console.log("loaded no error");
			//					window.close();
			//				}
			//			}
			//		});	
			//}
		}
	};
};

function hint(sf,cb) {
	var r=0;
	cb=cb||function(){console.log('completed');};
	function _hint(i) {
		if (i < sf.length) {
			exec('"'+npath.resolve(__dirname+'/../../node_modules/jshint/bin/jshint')+'" browser:true "'+sf[i]+'" --reporter="'+npath.resolve(__dirname+'/../reporter.js')+'"', function (error, stdout, stderr) {
				if (stdout) {
					r++;
					if (r==1) {
						console.log('');
					}
					console.log(stdout);
				}
				i++;
				_hint(i);
			});
		} else {
			cb(r);
		}
	}
	_hint(0);
}

function hints(caption,jsdir,defdir,next){
	next=next||function(){};
	process.stdout.write(caption);
	cfg[jsdir]=cfg[jsdir]||defdir;
	var sf=func.srcStruct(wd+cfg[jsdir]);
	if (!(sf && sf.length)) {
		console.log(clc.empty('no source\n'));
		next();
	} else {
		hint(sf,function(r){
			if(r){
				console.log(clc.warn('completed with error\n'));
			} else {
				console.log(clc.white('completed'));
			}
			next();
		});
	}
}

function minify(sf,dest,glb,cb) {
	cb=cb||function(){};
	
	var rndfl='all'+(new Date()).getTime()+'.js';
	var concat = new Concat(false, rndfl, '\n');
	for(var i=0;i<sf.length;i++){
		concat.add(path.basename(sf[i]), fs.readFileSync(sf[i]));
	}
	console.log('tmp file:'+func.tmpdir+'/'+rndfl);
	fs.writeFileSync(func.tmpdir+'/'+rndfl, concat.content);
	
	var s='"'+npath.resolve(__dirname+'/../../node_modules/uglify-js/bin/uglifyjs')+'" "'+(func.tmpdir+'/'+rndfl)+'" ';
	s+=('-o "'+dest+'" '+
	'--wrap='+glb+' --export-all '+
//	'-c');
	'-c -m');
//	'');
	
	//concat.add('file1.js', file1Content);
	//concat.add('file2.js', file2Content, file2SourceMap);
	
//	var s='"'+npath.resolve(__dirname+'/../../node_modules/uglify-js/bin/uglifyjs')+'" ';
//	for(var i=0;i<sf.length;i++){
//		s+='"'+sf[i]+'" ';
//	}
//	s+=('-o "'+dest+'" '+
//	'--wrap='+glb+' --export-all '+
////	'-c');
////	'-c -m');
//	'');
	exec(s, function (error, stdout, stderr) {
		var err=false;
		if (error) {
			console.log('uglify error :');
			console.log(error);
			err=true;
		}
		if (stderr) {
			console.log('uglify output (with error) :');
			console.log(stderr);
			err=true;
		}
		if (stdout) {
			console.log('uglify output :');
			console.log(stdout);
			err=true;
		}
		if (!err) {
			console.log('finished');
		}
		cb(err);
	});
}

function builds(caption,jsdir,defdir,bldsrc,staticdir,staticdef,dist,defdist,next){
	next=next||function(){};
	process.stdout.write(caption);
	cfg[jsdir]=cfg[jsdir]||defdir;
	cfg[dist]=cfg[dist]||defdist;
	cfg[staticdir]=cfg[staticdir]||staticdef;
	var dest=wd+cfg[dist];
	if(typeof cfg.clearDistDir == 'undefined') {
		cfg.clearDistDir=true;
	}
	if (cfg.clearDistDir) {
		func.deleteFolderRecursive(dest);
	}
	var sf=[];
	if (cfg && cfg[bldsrc] && cfg[bldsrc].length) {
		for (var i=0;i<cfg[bldsrc].length;i++){
			sf.push((wd+cfg[jsdir]).replace(/\/$/,'')+'/'+cfg[bldsrc][i]);
		}
	} else {
		sf=func.srcStruct(wd+cfg[jsdir]);
	}
	if (sf && sf.length) {
		var glb=cs.camel(cfg.name);
		func.createRecDir(dest,function(err){
			if (err) {
				console.log(clc.error('cannot create dir : '+dest));
				if (!(func.p.options && func.p.options.nostatic)) {
					statics(cfg[staticdir],cfg[dist],next);
				} else {
					next();
				}
			} else {
				minify(sf,dest+'/'+cfg.name+'.js',glb,function(){
					if (!(func.p.options && func.p.options.nostatic)) {
						statics(cfg[staticdir],cfg[dist],next);
					} else {
						next();
					}
				});
			}
		});
	} else {
		console.log(clc.empty('no source'));
		//statics(cfg[staticdir],cfg[dist],next);
		if (!(func.p.options && func.p.options.nostatic)) {
			statics(cfg[staticdir],cfg[dist],next);
		} else {
			next();
		}
	}
}

function statics(staticdir,dist,next) {
	process.stdout.write(' copy static files : ');
	func.fileExists(wd+staticdir,function(d){
		if (d=='dir') {
			ncp(wd+staticdir,wd+dist,function(e){
				//console.log('arguments',arguments);
				console.log('completed');
				sf=func.srcStruct(wd+dist,/\.css$/);
				if (sf && sf.length) {
					console.log(' minifying css...');
					cssmin(sf,function(){
						console.log(' completed...');
						next();
					});
				} else {
					next();
				}
			});
		} else {
			console.log(clc.empty('dir not found'));
			next();
		}
	})
}

function isIgnore(src,ig) {
	src=src||'';
	ig=ig||[];
	for(var i=0;i<ig.length;i++){
		if (src.match(new RegExp(ig[i]))) {
			return true;
		}
	}
	return false;
}
function cssmin(sf,cb) {
	var r=0;
	cb=cb||function(){console.log('finished');};
	function _cssmin(i) {
		if (i < sf.length) {
			if (!isIgnore(sf[i],cfg.minifyIgnore)) {
				func.readFile(sf[i],function(dt){
					new CleanCSS().minify(dt,function(errors, minified) {
						if(errors){ console.log(errors); } 
						setTimeout(function(){
							func.createFile(sf[i],minified.styles,function(crd){
								if (crd) {
									console.log('  '+sf[i]+clc.white(' minified'));
								} else {
									console.log(clc.error('   can not write file :'+sf[i]));
								}
								i++;
								_cssmin(i);
							});
						},500);
					});
				});
			} else {
				i++;
				_cssmin(i);
			}
		} else {
			cb(r);
		}
	}
	_cssmin(0);
}

/*
libdep	:editorLibDependencies,
dest	:editorDistDir,
destdef :'dist/editor',



*/
//function tests(libdep,dest,destdef){
//	cfg[libdep]=cfg[libdep]||[];
//	if (!util.isArray(cfg[libdep])) {
//		cfg[libdep]=[cfg[libdep]];
//	}
//	var libpath=wd+'esm_libs/';
//	var depSort=depend.sort(depend.lib(cfg[libdep],libpath));
//	//console.log(depSort);
//	var libfls=depend.jslib(depSort,libpath);
//	
//	console.log(depend.csslib(depSort,libpath));
//	return;
//	
//	var src='<!DOCTYPE html><html><head>';
//	for (var i=0;i<libfls.length;i++){
//		src+='<script src="'+libfls[i]+'"></script>';
//	}
//	cfg[dest]=cfg[dest]||destdef;
//	var clib=wd+cfg[dest]+'/'+cfg.name+'.js';
//	src+='<script src="'+clib+'"></script>';
//	src+='</head><body></body></body>';
//	
//	var asrc=libfls;
//	asrc.push(clib);
//	jsdom.env(
//		'<div></div>',
//		{
//			scripts: asrc,
//			done: function (errors, window) {
//				console.log(window.document.documentElement.outerHTML);
//				if (errors) {
//					func.formatOutput(errors);
//				} else {
//					console.log(clc.white(cfg.name+' global ('+clc.bold('window.'+cs.camel(cfg.name))+') :'));
//					console.log(window['"'+cs.camel(cfg.name)+'"']);
//					console.log("loaded no error");
//					window.close();
//				}
//			}
//		});
//	
//	
//	//var doc = jsdom.jsdom(src, jsdom.defaultLevel);
//	//var window=doc.defaultView;
//	//doc.addEventListener("load", function(e) {
//	//	//console.log(arguments);
//	//	var window=e.target;
//	//	//console.log(window.emobiqEditor);
//	//	console.log(window.console);
//	//}, false);
//	////doc.done=function(){
//	////	console.log(arguments)
//	////}
//	//console.log(window.document.documentElement.outerHTML);
//	
//	//doc.onpointerlockchange=function(){console.log('onpointerlockchange===>');concole.log(arguments);}
//	//doc.onpointerlockerror=function(){console.log('onpointerlockerror===>');concole.log(arguments);}
//	//doc.onreadystatechange=function(){console.log('onreadystatechange===>');concole.log(arguments);}
//
//	
//	//cfg.appDistDir=cfg.appDistDir||'dist/app';
//	//
//	//scri.push(wd+cfg.appDistDir+'/'+cfg.name+'.js');
//	//console.log(scri);
//	//jsdom.env(
//	//	'<p><a class="the-link" href="https://github.com/tmpvar/jsdom">jsdom!</a></p>',
//	//	{
//	//		scripts: scri,
//	//		done: function (errors, window) {
//	//			console.log(window.document.documentElement.outerHTML);
//	//			if (errors) {
//	//				func.formatOutput(errors);
//	//			} else {
//	//				console.log(clc.white(cfg.name+' global ('+clc.bold('window.'+cs.camel(cfg.name))+') :'));
//	//				console.log(window.emobiqApp);
//	//				console.log("loaded no error");
//	//				window.close();
//	//			}
//	//		}
//	//	});	
//}

function tests(libdep,dest,destdef){
	var scri=[];
	//for (var i in ) {
	//	//code
	//}
	jsdom.env(
		'<p><a class="the-link" href="https://github.com/tmpvar/jsdom">jsdom!</a></p>',
		{
			scripts: scri,
			done: function (errors, window) {
				console.log(window.document.documentElement.outerHTML);
				if (errors) {
					func.formatOutput(errors);
				} else {
					//console.log(clc.white(cfg.name+' global ('+clc.bold('window.'+cs.camel(cfg.name))+') :'));
					console.log(window);
					console.log("loaded with no error");
					window.close();
				}
			}
		});	
}