var util = require('util');

var func=null,
	user=null,
	prompt = null,
	wd=null,
	fl=null,
	clc=null;

module.exports=function(fu){
	func=fu;
	wd=func.workingdir;
	fl=func.esmpackage;
	prompt=func.prompt;
	clc=func.clc;
	return function(){
		func.currentUser(function(e,r){
			if(e){
				console.log(func.clc.empty(e));
				return;
			}
			user=r;
			init();
		});
	};
};

var init=function(){
	func.fileExists(fl,function(f){
		if (!f) {
			packageProject({});
		} else if (f=='file') {
			func.readFile(fl,function(dt){
				if (dt===undefined) {
					console.log(clc.red('cannot read "'+fl+'" file'));
					process.exit();
				} else {
					var fdt=JSON.parse(dt);
					if (fdt) {
						packageProject(fdt);
					} else {
						prompt({'overwrite':{prompt:'file esm.json exists with diferent format, will be overwrite (Y/n) '}},function(e,r){
							if (e) {
								console.log('\n'+clc.empty('init canceled'));
								process.exit();
							}
							if (r && (((r.overwrite+'').trim()).toLowerCase()=='y' || !r.overwrite)) {
								packageProject({});
							} else {
								console.log('\n'+clc.empty('init canceled'));
								process.exit();
							}
						});
					}
				}
			});
		}
	});
};

function packageProject(dt) {
	function createJSON(r) {
		func.createFile(fl,JSON.stringify(r,true,'  '),function(rslt){
			if (rslt) {
				console.log(clc.bold.cyan('success:')+' package created');
			} else {
				console.log(clc.red('cannot create esm.json file'));
			}
		});
	}
	function initProject(r) {
		func.request(func.apiurl+'package/'+r.name, function (error, response, body) {
			if (!error && response.statusCode == 200) {
				var rslt= JSON.parse(body);
				if (rslt && rslt.s && !rslt.dt) {
					if (!r.version) {
						r.version='1.0.0';
					}
					if (!r.author) {
						r.author=(user.full_name||user.name)+(user.email?' <'+user.email+'>':'');
					}
					if (r.keywords) {
						if(util.isString(r.keywords)){
							r.keywords=((r.keywords).trim()).split(' ');
						}
					}
					rdir={
						dist:{
							app:'dist/app',
							editor:'dist/editor',
						},
						src:{
							app:{
								js:'app/js',
								static:'app/static',
							},
							editor:{
								js:'editor/js',
								static:'editor/static',
							}
						}
					};
					
					r.dir=r.dir||{};
					r.dir.dist=r.dir.dist||{};
					r.dir.src=r.dir.src||{};
					r.dir.src.app=r.dir.src.app||{};
					r.dir.src.editor=r.dir.src.editor||{};
					
					r.dir.dist.app=r.dir.dist.app||rdir.dist.app;
					r.dir.dist.editor=r.dir.dist.editor||rdir.dist.editor;
					r.dir.src.app.js=r.dir.src.app.js||rdir.src.app.js;
					r.dir.src.app.static=r.dir.src.app.static||rdir.src.app.static;
					r.dir.src.editor.js=r.dir.src.editor.js||rdir.src.editor.js;
					r.dir.src.editor.static=r.dir.src.editor.static||rdir.src.editor.static;
					
					//r.appJsDir=r.appJsDir||'app/js';
					//r.appStaticDir=r.appStaticDir||'app/static';
					//r.editorJsDir=r.editorJsDir||'editor/js';
					//r.editorStaticDir=r.editorStaticDir||'editor/static';
					//r.appDistDir=r.appDistDir||'dist/app';
					//r.editorDistDir=r.editorDistDir||'dist/editor';
					func.createMultiDir([
						wd+r.dir.src.app.js,
						wd+r.dir.src.app.static,
						wd+r.dir.src.editor.js,
						wd+r.dir.src.editor.static,
						wd+r.dir.dist.app,
						wd+r.dir.dist.editor
					],function(e){
						if (e) {
							console.log(clc.red('ERROR : cannot create folder "'+e+'"'));
						} else {
							createJSON(r);
						}
					});
					//func.autoCreateDir(wd+'app',function(adir){
					//	if (adir) {
					//		func.autoCreateDir(wd+'editor',function(edir){
					//			if (edir) {
					//				createJSON(r);
					//			} else {
					//				console.log(clc.red('cannot create editor dir'));
					//			}
					//		});
					//	} else {
					//		console.log(clc.red('cannot create app dir'));
					//	}
					//});
				} else if(rslt && rslt.dt){
					console.log(clc.red('package whith name "'+r.name+'" already exists, change to other name'));
				} else if(rslt && !rslt.s){
					if (rslt.err) {
						console.log(clc.red(rslt.err));
					} else {
						console.log(clc.red('unknow error'));
					}
				} else {
					console.log(clc.red('unknow error'));
				}
			} else {
				console.log(clc.red('connection error'));
			}
		});
	}
	dt=dt||{};
	var arg={};
	if (!dt.name || !dt.description || !dt.keywords) {
		if (!dt.name) {
			arg.name={
				prompt:' Package name : ',
				pattern: /^[\w\-]+$/,
				message: 'Name must be only word or dashes',
				required:true
			};
		}
		if (!dt.description) {
			arg.description={
				prompt:' Description  : ',
			};
		}
		if (!dt.keywords) {
			arg.keywords={
				prompt:' Keywords (space separator): ',
			};
		}
		prompt(arg,function(e,r){
			if (e) {
				console.log('\n'+clc.empty('init canceled'));
				process.exit();
			}
			for(var i in dt){
				r[i]=dt[i];
			}
			initProject(r);
		});
	} else {
		initProject(dt);
	}
}

function createProjectDir(wd,cb) {
	var dir=[
		wd+'app',
		wd+'app/js',
		wd+'app/static',
		wd+'editor',
		wd+'editor/js',
		wd+'editor/static',
		wd+'dist',
		wd+'dist/app',
		wd+'dist/editor'
	];
	cb=cb||function(){};
	function mdr(i) {
		if (i<dir.length) {
			func.autoCreateDir(dir[i],function(adir){
				if (adir) {
					mdr(i+1);
				} else {
					cb('cannot create '+dir[i]+' dir');
				}
			});
		} else {
			cb(false);
		}
	}
}