var jsdom	= require('jsdom'),
	path	= require('path'),
	cs		= require('../change_case');

var f;

function getdeps(app,modIds,libIds,cb){
	libIds=libIds||[];
	var ids=modIds||[];
	var fids=[];
	ids.forEach(function(v){
		if (fids.indexOf(v) < 0) {
			fids.push(v);
		}
	});
	f.request(f.emobiqurl+'esm.php?app='+app+'&path=deps&id='+fids,function(e, res, body) {
		if (e) { cb(e); return; }
		var r; try { r= JSON.parse(body); } catch(e) { cb(e); return; }
		//console.log('r==>',r);
		if (!r.s) { cb(r.err); return; }
		if (!r.dt) {  cb('no data response'); return;  }
		var libs=(r.dt.libs && r.dt.libs.deps)?r.dt.libs.deps:[];
		libs.push.apply(libs,libIds);
		if (!libs.length) {
			cb(null,r.dt);
			return;
		}
		f.request(f.emobiqurl+'esm.php?app='+app+'&path=libs&id='+libs.join(','),function(e, res, body) {
			if (e) { cb(e); return; }
			var r2; try { r2= JSON.parse(body); } catch(e) { cb(e); return; }
			if (!r2.s) { cb(r2.err); return; }
			if (!r2.dt) {  cb('no data response'); return;  }
			
			r.dt.libs=r2.dt;
			cb(null,r.dt);
		});
	});
}

function addPrefix(a,pf) {
	a=a||[];
	var b=[];
	a.forEach(function(v){
		if (v.match(/^\.\//)) {
			b.push(pf+v.replace(/^\.\//,''))
		} else {
			b.push(v);
		}
	});
	return b;
}

module.exports=function(fu){
	f=fu;
	var clc=f.clc,
		wd=f.workingdir,
		cfg,
		id;
		
	try {
		cfg=require(wd+'esm.json');
	} catch(err) {
		cfg=null;
	}
	if (cfg) {
		id=cs.camel(cfg.name);
	}
	//var id=cs.camel(cfg.name);
	
	return f.test=function(cb){
		if (!id) {
			console.log(clc.error('no esm package'));
			return;
		}
		var scri=[],
			scrie=[];
		
		function test() {
			var appTest=function(window,self,done){
				//console.log('app==>',self);
				done();
			};
			var editorTest=function(window,self,done){
				//console.log('editor==>',self);
				done();
			}
			if (!cb) {
				console.log(clc.empty('app script test...'));
			}
			tests({
				scripts:scri,
				id:id,
				test:appTest,
				title:'app'
			},function(e){
				if(e){
					if (cb) { cb(e); return; }
					console.error(e);
					//console.log(clc.red(e.toString()));
					return;
				}
				console.log(clc.empty(' app test completed'));
				if (!cb) {
					console.log(clc.empty('editor script test...'));
				}
				tests({
						scripts:scrie,
						id:id,
						test:editorTest,
						title:'editor'
					},function(e){
						if(e && !cb){
							//console.log(clc.red(e.toString()));
							console.error(e);
							return;
						}
						if(cb){ cb(e); return; }
						console.log(clc.empty(' editor test completed'));
					});
			});
		}
		
		getdeps('app',cfg.dependencies||[],cfg.libs||[],function(e,r){
			if (e) { console.log(e); return; }
			var appDeps=r;
			//console.log('appDeps==>',appDeps.libs); return;
			
			getdeps('editor',cfg.dependencies||[],cfg.editorLibs||[],function(e,r2){
				if (e) { console.log(e); return; }
				var editorDeps=r2;
				
				if (appDeps.default && appDeps.default.js && Array.isArray(appDeps.default.js)) {
					scri.push.apply(scri,appDeps.default.js);
				}
				if(appDeps.libs && appDeps.libs.src && appDeps.libs.src.js){
					scri.push.apply(scri,appDeps.libs.src.js);
				}
				scri.push.apply(scri,f.config.emobiqApp.res);
				if(appDeps.modules && appDeps.modules.src && appDeps.modules.src.js){
					scri.push.apply(scri,f.values(appDeps.modules.src.js));
				}
				scri.push('file://'+path.resolve('./'+cfg.dir.dist.app)+'/'+id+'.js');

				//f.config.emobiqApp.res.forEach(function(v){
				//	scri.push(v);
				//});
				
				//f.config.emobiqEditor.res.forEach(function(v){
				//	scrie.push(v);
				//});
				
				if (editorDeps.default && editorDeps.default.js && Array.isArray(editorDeps.default.js)) {
					scrie.push.apply(scrie,editorDeps.default.js);
				}
				if(editorDeps.libs && editorDeps.libs.src && editorDeps.libs.src.js){
					scrie.push.apply(scrie,editorDeps.libs.src.js);
				}
				scrie.push.apply(scrie,f.config.emobiqEditor.res);
				if(editorDeps.modules && editorDeps.modules.src && editorDeps.modules.src.js){
					scrie.push.apply(scrie,f.values(editorDeps.modules.src.js));
				}
				scrie.push('file://'+path.resolve('./'+cfg.dir.dist.editor)+'/'+id+'.js');
				
				scri=addPrefix(scri,f.config.emobiqApp.url);
				scrie=addPrefix(scrie,f.config.emobiqEditor.url);
				
				//console.log('scri==>',scri);
				//console.log('scrie==>',scrie);
				//return;
				test();
				
			});
		});
		
		
	};
};

function tests(opts,cb){
	var scri=opts.scripts,
		test=opts.test,
		id=opts.id;
		title=opts.title;
	if (!cb) { console.log(clc.empty(title+' test start')); }
	//jsdom.env(
	//	'<div></div>',
	//	{
	//		scripts: scri,
	//		done: function (e, window) {
	//			//console.log(window.document.documentElement.outerHTML);
	//			if (e) {
	//				if (!cb) { console.log(clc.red(e.toString())); }
	//				else { cb(e); }
	//				window.close();
	//				return;
	//			}
	//			try {
	//				var x=window[id];
	//				if (!x) {
	//					console.log(clc.empty(' empty '+title+' script'));
	//				}
	//				test(window,x,function(e){
	//					if(cb){ cb(e); }
	//					else {
	//						console.log(clc.empty(title+' test complete'));
	//					}
	//				});
	//			} catch(ee) {
	//				if (!cb) { console.log(clc.red(ee.toString())); }
	//				else { cb(ee); }
	//				window.close();
	//				return;
	//			}
	//			window.close();
	//		}
	//	});
	
	jsdom.env({
		html:'<div></div>',
		scripts: scri,
		created:function(e, window){
			window.addEventListener("error", function (event) {
				console.error("script error!!", event.error);
				//process.exit();
			});
			navigator = window.navigator;
			window.localStorage = window.sessionStorage = {
				getItem: function (key) {
					return this[key];
				},
				setItem: function (key, value) {
					this[key] = value;
				}
			};	
		},
		done: function (e, window) {
			if (f.p.options && f.p.options.show) {
				console.log('html ==>',window.document.documentElement.outerHTML);
			}
			if (e) {
				if (!cb) { console.log(clc.red(e.toString())); }
				else { cb(e); }
				window.close();
				return;
			}
			try {
				var x=window[id];
				if (!x) {
					//console.log(clc.empty(' no exported '+title+' script'));
				}
				test(window,x,function(e){
					if(cb){ cb(e); }
					else {
						console.log(clc.empty(title+' test completed'));
					}
				});
			} catch(ee) {
				if (!cb) { console.log(clc.red(ee.toString())); }
				else { cb(ee); }
				window.close();
				return;
			}
			window.close();
		}
	});
}