var util=require('util'),
	fs=require('fs');

module.exports={
	lib:function(depend,dir){
		var o={};
		for(var i=0;i<depend.length;i++){
			var pac=require(dir+depend[i]+'/esm-lib.json');
			if (pac) {
				pac.dependencies=pac.dependencies||[];
				if (!util.isArray(pac.dependencies)) {
					pac.dependencies=[pac.dependencies];
				}
				o[depend[i]]=pac.dependencies;
			}
		}
		return o;
	},
	jslib:function(depend,dir){
		var s=[];
		for (var i=0;i<depend.length;i++){
			var sf=srcStruct(dir+depend[i]);
			for (var j=0;j<sf.length;j++){
				s.push(sf[j]);
			}
		}
		return s;
	},
	csslib:function(depend,dir){
		var s=[];
		for (var i=0;i<depend.length;i++){
			var sf=srcStruct(dir+depend[i],/\.css$/);
			for (var j=0;j<sf.length;j++){
				s.push(sf[j]);
			}
		}
		return s;
	},
	sort:function (dependencies, root){
		var nodes={};
		var nodeCount=0;
		var ready=[];
		var output=[];
	
		// build the graph
		function add(element){
			nodeCount++;
			nodes[element]={needs:[], neededBy:[], name: element};
			if(dependencies[element]){
				dependencies[element].forEach(function(dependency){
					if(!nodes[dependency]) add(dependency);
					nodes[element].needs.push(nodes[dependency]);
					nodes[dependency].neededBy.push(nodes[element]);
				});
			}
			if(!nodes[element].needs.length) ready.push(nodes[element]);
		}
		 
		if(root){
			add(root)
		} else {
			for (element in dependencies){
				if(!nodes[element]) add(element);
			}
		}
	
		//sort the graph
		while(ready.length){
			var dependency = ready.pop();
			output.push(dependency.name);
			dependency.neededBy.forEach(function(element){
				element.needs = element.needs.filter(function(x){return x!=dependency})
				if(!element.needs.length) ready.push(element)
			})
		}
	
		//error-check
		if(output.length != nodeCount){
			throw "circular dependency detected"
		}
		return output;
	}
};

function srcStruct(pth,mtch){
	mtch=mtch||/\.js$/;
	var hpath=[];
	function struct(pth2){
			if (fs.lstatSync(pth2).isDirectory()) {
				files = fs.readdirSync(pth2);
				files.forEach(function(file,index){
					var curPath = pth2 + "/" + file;
					if(fs.lstatSync(curPath).isDirectory()) { // recurse
						struct(curPath);
					} else { // delete file
						if (curPath.match(mtch)) {
							hpath.push(curPath);
						}
					}
				});
				//fs.rmdirSync(pth2);
			} else {
				if (pth2.match(mtch)) {
					hpath.push(pth2);
				}
			}
	}
	if(fs.existsSync(pth)) {
		struct(pth);
	}
	return hpath;
}