var cs = require('./change_case');
var f, clc, wd, cfg, id, modName, l='dependencies';
module.exports=function(fu){
	f=fu;
	clc=f.clc,
	wd=f.workingdir;

	return {
		ls:ls,
		install:install,
		uninstall:uninstall,
		command:command,
	}
};

function init(cb){
	try {
		cfg=require(wd+'esm.json');
	} catch(err) {
		cfg=null;
	}
	if (cfg) {
		id=cs.camel(cfg.name);
	}
	if (!id) {
		console.log(clc.error(f.msg.esm_pkg_doesnt_exists));
		return;
	}
	cb();
}
function simpleCommand(cb){
	init(function(){
		var scs=f.p.subcommand,sc;
		scs=!Array.isArray(scs)?[scs]:scs;
		if (scs.length) {
			modName=scs[0];
		}
		if (!modName) {
			console.log(clc.empty(f.sprintf(f.msg.invalid_params,'package_id')));
			return;
		}
		cb();
	});
}

function install(){
	simpleCommand(function(){
		check(function(){
			add(modName);
			save();
		});
	});
}

function uninstall(){
	simpleCommand(function(){
		remove(modName);
		save();
	});
}

function check(cb) {
	f.request(f.apiurl+'package/'+modName,function(e, r, body) {
		if (e) {
			console.log(clc.error(f.msg.error + e.toString()));
			return;
		}
		var o=JSON.parse(body);
		if (!o.s) {
			console.log(clc.error((o.err||o.error).toString()));
			return;
		}
		if (!o.dt) {
			console.log(clc.empty(f.sprintf(f.msg.package_not_found,modName)));
			return;
		}
		cb();
	});
}

function command() {
	init(function(){
		var scs=f.p.subcommand,
			sc;
		if (scs && scs.length) {
			scs=!Array.isArray(scs)?[scs]:scs;
			sc=scs[0];
			if (scs.length > 1) {
				modName=scs[1];
			}
			
			if (sc=='ls') {
				ls();
			} else if(sc=='add' || sc=='install'){
				if (!modName) {
					console.log(clc.empty(f.sprintf(f.msg.invalid_params,'package_id')));
					return;
				}
				check(function(){
					add(modName);
					save();
				})
			} else if(sc=='rem' || sc=='remove' || sc=='del' || sc=='delete' || sc=='uninstall'){
				if (!modName) {
					console.log(clc.empty(f.sprintf(f.msg.invalid_params,'package_id')));
					return;
				}
				remove(modName);
				save();
			} else {
				console.log(clc.error(f.sprintf(f.msg.invalid_sub_command,sc)))
			}
		} else {
			ls();
		}
	});
}

function ls() {
	if (cfg[l] && cfg[l].length) {
		f.formatOutput(cfg[l],2);
	} else {
		console.log(clc.empty(f.msg.no_module_deps))
	}
}

function add(lib) {
	cfg[l]=cfg[l]||[];
	if (cfg[l].indexOf(lib) < 0) {
		cfg[l].push(lib);
	}
}

function remove(lib) {
	cfg[l]=cfg[l]||[];
	var i=cfg[l].indexOf(lib);
	if (i > -1) {
		cfg[l].splice(i,1);
	}
}

function save(){
	f.createFile(f.esmpackage,JSON.stringify(cfg,true,'  '),function(r){
		if (r) {
			console.log(f.clc.info(f.msg.pkg_updated));
		} else {
			console.log(f.clc.red(f.sprint(f.msg.cannot_write_file,'esm.json')));
		}
	});
}