var util = require('util');
var help=require('./../help.json');

function srepeat(s,n) {
	return (new Array(n+1).join(s));
}

function showHelp(h) {
	function format1(hs,s) {
		if (!util.isArray(hs)) {
			hs=[hs];
		}
		console.log('\n'+s+hs[0]);
		for(var i=1;i<hs.length;i++){
			console.log(srepeat(' ',s.length)+hs[i]);
		}
	}
	function format2(hs,s,l) {
		l=l||3;
		if (!util.isArray(hs)) {
			hs=[hs];
		}
		console.log('\n'+s);
		for(var i=0;i<hs.length;i++){
			console.log((srepeat(' ',3))+hs[i]);
		}
	}
	if (h.usage) {
		format1(h.usage,' Usage: ');
	}
	if (h.description) {
		format1(h.description,' ');
	}
	if (h.options) {
		format2(h.options,' Options: ');
	}
	if (h.notes) {
		var hs=h.notes;
		if (!util.isArray(hs)) {
			hs=[hs];
		}
		for(var i=0;i<hs.length;i++){
			if (!(hs[i].title)) {
				//console.log('\n '+hs[i]);
				format1(hs[i],' ');
			} else {
				format2(hs[i].content,' '+hs[i].title);
			}
		}
	}
	console.log('');
}

module.exports=function(p){
	p=p||{options:{},command:'',arguments:[]};
	if (p.options.v || p.options.version && !p.command) {
		console.log('esm version:'+help.version);
	} else if(!p.command){
		showHelp(help);
	} else if (help.commands[p.command]) {
		showHelp(help.commands[p.command]);
	} else {
		console.log('no command found');
	}
};