var path = require('path'),
    r = require('rollup'),
    babel = require('rollup-plugin-babel');

module.exports = function rollup ( inputdir, outputdir, options , bundleOptions, cb) {

	if ( !options.entry ) {
		throw new Error( 'You must supply `options.entry`' );
	}

	options.entry = path.resolve( inputdir, options.entry );

    options.plugins=[
        babel({
            exclude: 'node_modules/**',
            babelrc: false,
			runtimeHelpers: true,
			presets: [__dirname+'/../node_modules/babel-preset-es2015-rollup'], // ['es2015-rollup'],
            plugins: [__dirname+'/../node_modules/babel-plugin-transform-class-properties', //['transform-class-properties'],
                     __dirname+'/../node_modules/babel-plugin-syntax-export-extensions'], //['syntax-export-extensions'],
        })
    ];

	return r.rollup( options )
        .then( function ( bundle ) {
        	return bundle.write( bundleOptions );
        })
        .then(function(){
                cb();
            },function(e){
                cb(e);
            });
};
